local TheInput = GLOBAL.TheInput
GetPlayer = GLOBAL.GetPlayer

modimport "transformation.lua"

local MOBS =
{
	"minotaur",
	"beefalo",
	"manrabbit",
	"manrabbit_beard",
	"hound",
	"hound_ice",
	"hound_red",
	"deerclops",
	"leif",
	"pigman",
	"pig_guard",
	"werepig",
	"spider",
	"spider_warrior",
	"spiderqueen",
	"worm",

	--ROG
	--"dragonfly",
}

local current = 0

local function oncollide(inst, other)
    if other == nil or not other:HasTag("tree") then return end

    local v1 = GLOBAL.Vector3(inst.Physics:GetVelocity())
    if v1:LengthSq() < 1 then return end

    inst:DoTaskInTime(2*GLOBAL.FRAMES, function()
        if other and other.components.workable and other.components.workable.workleft > 0 then
            GLOBAL.SpawnPrefab("collapse_small").Transform:SetPosition(other:GetPosition():Get())
            other.components.workable:Destroy(inst)
        end
    end)

end

local function MobAbility()
	if MOBS[current] == "deerclops" then
		GetPlayer().components.worker:SetAction(GLOBAL.ACTIONS.HAMMER, 4)
		GetPlayer():ListenForEvent("onhitother", function(inst, data)
			local other = data.target
			if other and other.components.freezable and MOBS[current] == "deerclops" then
				other.components.freezable:AddColdness(2)
				other.components.freezable:SpawnShatterFX()
			end
		end)
		GetPlayer().Physics:SetCollisionCallback(oncollide)
	else
		GetPlayer().Physics:SetCollisionCallback(nil)
	end
	if MOBS[current] == "minotaur" then
		GetPlayer().Physics:SetCollisionCallback(oncollide)
	else
		GetPlayer().Physics:SetCollisionCallback(nil)
	end
end

local function KeyboardAbility()
	if MOBS[current] == "spiderqueen" then GetPlayer().sg:GoToState("poop") end
end

local function SelectMob()
	if not GetPlayer().sg:HasStateTag("moving") then
		current = current + 1
		if current > #MOBS then
			current = 1
		end
		Transform(MOBS[current])
		MobAbility()
		GLOBAL.c_sethealth(1)
	end
end

local function Untransform()
	local name = GetPlayer().prefab
	if name ~= "waxwell" then
		GetPlayer().components.sanity.dapperness = 0
	end
	if name ~= "webber" then
		GetPlayer().components.eater.monsterimmune = false
		GetPlayer().components.locomotor.triggerscreep = true
	end
	GetPlayer().components.talker:StopIgnoringAll()
	GetPlayer().AnimState:SetBank("wilson")
	GetPlayer().AnimState:SetBuild(name)
	GetPlayer():SetStateGraph("SGwilson")
	GetPlayer():RemoveTag("spider")
	GetPlayer():RemoveTag("pig")
	GetPlayer():RemoveTag("monster")
	GetPlayer():RemoveTag("tree")
	GetPlayer():RemoveTag("leif")
	current = 0
	GetPlayer().Transform:SetScale(1,1,1)
	GetPlayer().entity:AddDynamicShadow():SetSize(1.3, .6)
	GetPlayer().components.locomotor.runspeed = 7
	GetPlayer().components.playercontroller.actionbuttonoverride = nil
	GetPlayer().components.playeractionpicker.leftclickoverride = nil
	GetPlayer().components.playeractionpicker.rightclickoverride = nil
end

---------------------------------------------------------

local function Taunt()
	if MOBS[current] == "pigman" or MOBS[current] == "pig_guard" or MOBS[current] == "manrabbit" then
		GetPlayer().AnimState:PlayAnimation("idle_angry")
	elseif MOBS[current] == "beefalo" then
		GetPlayer().sg:GoToState("bellow")
	elseif MOBS[current] ~= "dragonfly" then
		GetPlayer().sg:GoToState("taunt")
	end
end

local function Sleep()
	if not GetPlayer().sg:HasStateTag("sleeping") then
		if MOBS[current] ~= "leif" then
			GetPlayer().sg:GoToState("sleep")
		else
			GetPlayer().sg:GoToState("sleeping")
		end
	else
		GetPlayer().sg:GoToState("wake")
		GetPlayer().components.playercontroller:Enable(true)
	end
end

TheInput:AddKeyDownHandler(GetModConfigData("transform_key"), SelectMob)
TheInput:AddKeyDownHandler(GetModConfigData("taunt_key"), Taunt)
TheInput:AddKeyDownHandler(GetModConfigData("sleep_key"), Sleep)
TheInput:AddKeyDownHandler(GetModConfigData("ability_key"), KeyboardAbility)
TheInput:AddKeyDownHandler(GetModConfigData("untransform_key"), Untransform)
